src/medux/plugins/cashbook/urls.py
from django.urls import path, include

from . import views

app_name = "cashbook"

entry_patterns = [
    path("", views.CashbookEntryList.as_view(), name="index"),
    path("add/", views.CashbookEntryCreateView.as_view(), name="add"),
]

urlpatterns = [
    path(
        "entry/", include((entry_patterns, "entry"), namespace="entry  "), name="entry"
    ),
]

src/medux/plugins/cashbook/models.py
from django.contrib.auth import get_user_model
from django.db import models
from django.db.transaction import atomic
from django.utils.translation import gettext_lazy as _
from djmoney.models.fields import MoneyField

from medux.common.models import (
    TenantModelMixin,
    CreatedModifiedModel,
    OptionalTenantModelMixin,
)
from medux.preferences.models import ScopedPreference

User = get_user_model()


class Balance(CreatedModifiedModel):
    """Represents an account balance at a certain timestamp.

    Do NOT create a Balance yourself, this model is automatically created when
    adding an Entry."""

    amount = MoneyField(max_digits=19, decimal_places=2, default_currency="EUR")

    class Meta:
        verbose_name = _("Balance")
        verbose_name_plural = _("Balances")

    def __str__(self):
        return f"{self.amount}"


class VatRate(OptionalTenantModelMixin, models.Model):
    vat = models.DecimalField(max_digits=4, decimal_places=2, unique=True)

    def __str__(self):
        return f"{self.vat} %"

    def save(self, **kwargs):
        # TODO: check if running initial migration. if not, deny saving pk==1
        super().save(**kwargs)

    def delete(self, using=None, keep_parents=False):
        """Makes sure that if deleted vat_rate was the default one, all default_vat in
        preferences are set back to 1"""
        if self.pk == 1:
            raise PermissionError("0% VatRate cannot be deleted.")
        else:
            # get all default_vat objects (possible mult. scopes) from settings
            ScopedPreference.objects.filter(
                namespace="cashbook", key="default_vat", tenant=self.tenant
            ).update(value=1)


# def get_default_vat():
#     return ScopedPreference.get("cashbook","default_vat", "1")


class Entry(TenantModelMixin, CreatedModifiedModel):
    # TODO: make currency configurable
    amount = MoneyField(max_digits=19, decimal_places=2, default_currency="EUR")
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    balance = models.ForeignKey(Balance, on_delete=models.PROTECT, editable=False)
    comment = models.CharField(max_length=255, blank=True, null=True)
    vat_rate = models.ForeignKey(VatRate, on_delete=models.PROTECT)
    # payment = models.ForeignKey(...)
    # patient = models.ForeignKey(..., null=True)

    class Meta:
        verbose_name = _("Entry")
        verbose_name_plural = _("Entries")
        ordering = ["-created"]

    @atomic
    def save(self, *args, **kwargs):
        last = Balance.objects.last()
        if last:
            last_amount = last.amount
        else:
            last_amount = 0

        # create new balance entry with same timestamp
        balance = Balance(created=self.created)
        balance.amount = last_amount + self.amount
        balance.save()
        self.balance = balance
        super().save(*args, **kwargs)

    def __str__(self):
        return str(self.amount)

src/medux/plugins/cashbook/forms.py
from crispy_forms.bootstrap import AppendedText
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Row, Column, Submit, HTML
from django.forms import Select
from django.utils.translation import gettext_lazy as _
from django import forms
from djmoney.forms import MoneyField

from medux.plugins.cashbook.models import Entry


class EntryForm(forms.ModelForm):
    class Meta:
        model = Entry
        fields = ["amount", "comment", "vat_rate"]

    amount = MoneyField(
        # FIXME: disabling currency_widget leads to not returning amount to form
        #  see https://github.com/django-money/django-money/issues/720
        currency_widget=Select(choices=[("EUR", _("Euro"))], attrs={"hidden": True}),
        # currency_widget=Select(choices=[("EUR", _("Euro"))]),
        # currency_choices=[("EUR", _("Euro"))],
        # default_currency="EUR",
    )

    def __init__(self, **kwargs):
        super().__init__(**kwargs)
        self.fields["amount"].widget.attrs["autofocus"] = True
        # self.fields["amount"].widget.widgets[1].attrs["readonly"] = True
        self.helper = FormHelper(self)
        self.helper.layout = Layout(
            Row(
                # Column("amount"),
                # FIXME: don't hardcode EUR
                Column(AppendedText("amount", "Euro")),
                Column("comment"),
                Column("vat_rate"),
                Column(
                    HTML("<div>&nbsp;</div>"),  # placeholder for label
                    Submit("submit", _("Save"), css_class="mt-2"),
                ),
            ),
        )

    def clean_amount(self):
        amount = self.cleaned_data.get("amount")
        # if amount and amount.amount < 0:
        #     raise forms.ValidationError(_("Amount may not be negative."))
        return amount

src/medux/plugins/cashbook/views.py
#  MedUX - Open Source Electronical Medical Record
#  Copyright (c) 2021  Christian González
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Affero General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Affero General Public License for more details.
#
#  You should have received a copy of the GNU Affero General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
import logging

from django.db.models import Q
from django.http import HttpResponseRedirect
from django.views.generic import CreateView, ListView

from medux.common.htmx.mixins import HtmxResponseMixin

from medux.plugins.cashbook.forms import EntryForm
from medux.plugins.cashbook.models import Entry, VatRate

logger = logging.getLogger(__name__)


class CashbookMixin:
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context.update(
            {
                "available_vats": VatRate.objects.filter(
                    Q(tenant_id=self.request.user.tenant.pk) | Q(tenant_id=None),
                )
            }
        )
        return context


class CashbookEntryList(CashbookMixin, ListView):
    model = Entry
    permission_required = "cashbook.add_entry"
    template_name = "cashbook/entry_list.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context.update(
            {
                "objects": Entry.objects.filter(
                    tenant=self.request.user.tenant
                ).order_by("-created")[:100],
            }
        )
        return context


class CashbookEntryCreateView(CashbookMixin, HtmxResponseMixin, CreateView):
    model = Entry
    form_class = EntryForm
    permission_required = "cashbook.add_entry"
    template_name = "cashbook/entry_form.html"
    success_event = "cashbookentry:created"

    def get_initial(self):
        initial = super().get_initial()
        initial["vat_rate"] = VatRate.objects.get(pk=1)
        return initial

    def form_valid(self, form):
        entry = form.save(commit=False)
        entry.tenant = self.request.user.tenant
        entry.user = self.request.user
        entry.save()
        return HttpResponseRedirect(".")
        # return HttpResponseEmpty()

src/medux/plugins/cashbook/templates/cashbook/base.html
{% extends 'core/base.html' %}
{% load i18n %}

{% block title %}{% translate 'Medux - Cashbook' %}{% endblock %}

src/medux/plugins/cashbook/templates/cashbook/entry_form.html
{% load i18n crispy_forms_tags %}

<form id="form-cashbook-entry-add"
      method="post"
      hx-post="{% url 'cashbook:entry:add' %}"
      hx-target="#form-cashbook-entry-add"
      hx-swap="outerHTML"
>
    {% csrf_token %}
    {% crispy form %}

{#    <div class="input-group">#}
{#        <span class="input-group-text">{% translate 'New entry' %}:</span>#}
{#        <input type="text" name="amount" step="0.10"#}
{#               class="numberinput form-control{% if form.amount.errors %} is-invalid{% endif %}" required autofocus#}
{#               id="id_amount" placeholder="{{ form.amount.label }}"#}
{##}
{#        >#}
{##}
{#        <input type="text" name="comment" maxlength="255" class="textinput form-control" id="id_comment"#}
{#               placeholder="{{ form.label.comment }}">#}
{#        <div class="invalid-feedback">{{ form.comment.errors }}</div>#}
{##}
{#        <select name="vat_rate" class="select form-select"#}
{#                required id="id_vat_rate">#}
{#            {% for vat_rate in available_vats %}#}
{#                <option value="{{ vat_rate.id }}" {% if form.initial.vat_rate.id == vat_rate.id %}selected{% endif %}>#}
{#                    {{ vat_rate.vat }}%#}
{#                </option>#}
{#            {% endfor %}#}
{#        </select>#}
{#        <div class="invalid-feedback">{{ form.vat_rate.errors }}</div>#}
{##}
{#        <input type="submit" name="submit" value="{% translate 'Save' %}" class="btn btn-primary" id="submit-id-submit">#}
{#    </div>#}
    {{ form.non_field_errors }}
</form>

src/medux/plugins/cashbook/templates/cashbook/entry_list.html
{% extends 'cashbook/base.html' %}
{% load i18n static django_htmx crispy_forms_tags %}

{% block title %}{% translate 'Account activities' %}{% endblock %}
{% block page-title %}{% translate 'Account activities' %}{% endblock %}

{% block content %}

    <div class="card">
        <div class="card-header">
            <div hx-get="{% url 'cashbook:entry:add' %}"
                 hx-trigger="load"
            ></div>
        </div>

        <div class="table-responsive"
             id="cashbook_overview"
             hx-trigger="cashbookentry:created from:body"
             hx-target="#cashbook_overview"
             hx-select="#cashbook_overview"
             hx-get="{% url 'cashbook:entry:index' %}"
        >
            <table class="table table-striped table-sm">
                <thead>
                <tr>
                    <th>{% translate 'Date' %}</th>
                    <th>{% translate 'E/A' %}</th>
                    <th>{% translate 'VAT' %}</th>
                    <th>{% translate 'Comment' %}</th>
                    <th>{% translate 'Balance' %}</th>
                </tr>
                </thead>
                <tbody>
                {% for entry in entry_list %}
                    <tr title="{% translate 'Saved by:' %} {{ entry.user }}">
                        <td>{% ifchanged entry.created|date %}
                            {{ entry.created |date }}{% endifchanged %}</td>
                        <td {% if entry.amount.amount < 0 %}class="text-danger"{% endif %}>{{ entry.amount }}</td>
                        <td>{{ entry.vat_rate }}</td>
                        <td>{{ entry.comment|default:"" }}</td>
                        <td>{{ entry.balance }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
        </div>
    </div>


{% endblock %}